' ------------------------------------------------------------------------------------------------------------
' The support for this display has been made possible by Peter Ksters from (c) Display3000
' You can buy the displays from Display3000 or MCS Electronics
' ------------------------------------------------------------------------------------------------------------'
'
$lib "LCD-PCF8833.lbx"                                      'special color display support

$regfile = "m8def.dat"                                      'ATMega 8, change if using different processors
$crystal = 8000000

'First we define that we use a graphic LCD
Config Graphlcd = Color , Controlport = Portc , Cs = 1 , Rs = 0 , Scl = 3 , Sda = 2

'here we define the colors

Const Blue = &B00000011                                     'predefined contants are making programming easier
Const Yellow = &B11111100
Const Red = &B11100000
Const Green = &B00011100
Const Black = &B00000000
Const White = &B11111111
Const Brightgreen = &B00111110
Const Darkgreen = &B00010100
Const Darkred = &B10100000
Const Darkblue = &B00000010
Const Brightblue = &B00011111
Const Orange = &B11111000

'clear the display
Cls

'create a cross
'Line(0 , 0) -(130 , 130) , Blue
'Line(130 , 0) -(0 , 130) , Red


Showpic 0 , 0 , Mass
Showpic 0 , 32 , Mass
Showpic 0 , 64 , Mass
Showpic 0 , 96 , Mass

Showpic 32 , 00 , Folder
Showpic 32 , 32 , Folder
Showpic 32 , 64 , Folder
Showpic 32 , 96 , Folder

Showpic 64 , 00 , Enternet
Showpic 64 , 28 , Enternet
Showpic 64 , 60 , Enternet
Showpic 64 , 92 , Enternet

Showpic 96 , 00 , Mp3
Showpic 96 , 30 , Mp3
Showpic 96 , 62 , Mp3
Showpic 96 , 94 , Mp3

Wait 15

Box(0 , 0) -(128 , 128) , White

Showpic 0 , 00 , Dll
Showpic 0 , 32 , Dll
Showpic 0 , 64 , Dll
Showpic 0 , 96 , Dll

Showpic 32 , 00 , Sun
Showpic 32 , 32 , Sun
Showpic 32 , 64 , Sun
Showpic 32 , 96 , Sun
 Wait 10


Showpic 0 , 0 , Blue
Wait 5

''select a font
'Setfont Color16x16

''and show some text
'Lcdat 0 , 0 , "12345678" , Blue , Yellow
'Lcdat 15 , 0 , "ABCDEFGH" , Yellow , Blue
'Lcdat 30 , 0 , "LCDColor" , Red , Green
'Lcdat 45 , 0 , "Graphic" , Green , Red
'Lcdat 60 , 0 , "  AND  " , Black , White
'Lcdat 74 , 0 , "ATmega 8" , White , Black
'Lcdat 90 , 0 , "3.3 LCD" , Red , White
'Lcdat 100 , 0 , "6.3 Volt" , Darkgreen , Brightgreen
'Lcdat 115 , 0 , "BackLight" , Brightgreen , Darkred
'Wait 10


'make a box

Box(0 , 0) -(10 , 130) , Red
Box(10 , 0) -(20 , 130) , Yellow
Box(20 , 0) -(30 , 130) , Blue
Box(30 , 0) -(40 , 130) , Green
Box(40 , 0) -(50 , 130) , Black
Box(50 , 0) -(60 , 130) , White
Box(60 , 0) -(70 , 130) , Brightgreen
Box(70 , 0) -(80 , 130) , Darkgreen
Box(80 , 0) -(90 , 130) , Darkred
Box(90 , 0) -(100 , 130) , Darkblue
Box(100 , 0) -(110 , 130) , Brightblue
Box(110 , 0) -(120 , 130) , Orange
End


'$include "color.font"
'$include "color16x16.font"
Enternet:
$bgf "Enternet.BGC"
Sun:
$bgf "Sun.BGC"
Mp3:
$bgf "Mp3.BGC"
Dll:
$bgf "Dll.BGC"
Folder:
$bgf "Folder.BGC"
Mass:
$bgf "Maseig.BGC"
Blue:
$bgf "BLUETOTH.BGC"
'Mcs:
'$bgf "MCSE.BGC"