;CodeVisionAVR C Compiler V1.24.4 Standard
;(C) Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;e-mail:office@hpinfotech.com

;Chip type           : AT90S8535
;Clock frequency     : 4.000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : int, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Automatic register allocation : On

	.DEVICE AT90S8535
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0x30
	.EQU __sm_powerdown=0x20

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM


	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM


	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM


	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "led.vec"
	.INCLUDE "led.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.23.8c Professional
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : 
;      10 Version : 
;      11 Date    : 10/9/2004
;      12 Author  : MN                              
;      13 Company :                                 
;      14 Comments: 
;      15 
;      16 
;      17 Chip type           : AT90S8535
;      18 Clock frequency     : 4.000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 128
;      22 *********************************************/
;      23 
;      24 #include <90s8535.h>
;      25 #define numberfont 4
;      26 
;      27 flash char font[numberfont][16]=

	.CSEG
;      28 {
;      29     0x50, 0x71, 0x11, 0x1F, 0x00, 0x04, 0x00, 0x00, 
;      30     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 
;      31     0x08, 0xE9, 0xA9, 0xEF, 0x00, 0x00, 0x00, 0x00, 
;      32     0x00, 0x00, 0x00, 0x00, 0x0A, 0x08, 0x08, 0x08, 
;      33     0xC0, 0x20, 0x10, 0xF7, 0x04, 0x04, 0x04, 0x04, 
;      34     0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 
;      35     0x50, 0x49, 0x44, 0x43, 0x04, 0x08, 0x10, 0x00, 
;      36     0x00, 0x00, 0x00, 0x00, 0x40, 0x40, 0x40, 0x40
;      37 /*    
;      38     0x00, 0x81, 0x81, 0x9F, 0x90, 0x96, 0x90, 0xB4,     
;      39     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
;      40     0x2B, 0x02, 0x02, 0x13, 0x10, 0x10, 0x10, 0x73, 
;      41     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x00, 
;      42     0x97, 0x15, 0x15, 0x97, 0x80, 0x80, 0x80, 0x80, 
;      43     0x00, 0x00, 0x00, 0x02, 0xFE, 0x80, 0x10, 0x10, 
;      44     0x00, 0x9C, 0x94, 0xFC, 0x00, 0x00, 0x00, 0x01, 
;      45     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
;      46     0x08, 0x08, 0x08, 0x3F, 0x20, 0x20, 0x20, 0xE0, 
;      47     0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x02, 0x04,
;      48     0x00, 0x07, 0x05, 0x07, 0x01, 0x01, 0x01, 0x07, 
;      49     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
;      50 */    
;      51 };
;      52 //----------------								
;      53 int *p[3];

	.DSEG
_p:
	.BYTE 0x6
;      54 unsigned char bufferfontblocke[16];
_bufferfontblocke:
	.BYTE 0x10
;      55 unsigned char buffershowfonte[3][16];
_buffershowfonte:
	.BYTE 0x30
;      56 unsigned char buffernumfont=0;
;      57 char numshift=0;
;      58 //----------------
;      59 void shifte(char);
;      60 void refresh(void);
;      61 void delay(void);
;      62 
;      63 
;      64 void main(void)
;      65 {

	.CSEG
_main:
;      66 	char i,j;
;      67 	char k;
;      68 // Declare your local variables here
;      69 
;      70 // Input/Output Ports initialization
;      71 // Port A initialization
;      72 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;      73 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;      74 PORTA=0x00;
;	i -> R16
;	j -> R17
;	k -> R18
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;      75 DDRA=0x00;
	OUT  0x1A,R30
;      76 
;      77 // Port B initialization
;      78 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;      79 // State0=T State1=T State2=T State3=T State4=T State5=T State6=T State7=T 
;      80 PORTB=0xff;
	LDI  R30,LOW(255)
	OUT  0x18,R30
;      81 DDRB=0xff;
	OUT  0x17,R30
;      82 
;      83 // Port C initialization
;      84 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
;      85 // State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=1 State7=1 
;      86 PORTC=0xFF;
	OUT  0x15,R30
;      87 DDRC=0xFF;
	OUT  0x14,R30
;      88 
;      89 // Port D initialization
;      90 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=Out Func7=Out 
;      91 // State0=1 State1=1 State2=1 State3=1 State4=1 State5=1 State6=1 State7=1 
;      92 PORTD=0xFF;
	OUT  0x12,R30
;      93 DDRD=0xFF;
	OUT  0x11,R30
;      94 
;      95 // Timer/Counter 0 initialization
;      96 // Clock source: System Clock
;      97 // Clock value: Timer 0 Stopped
;      98 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;      99 TCNT0=0x00;
	OUT  0x32,R30
;     100 
;     101 // Timer/Counter 1 initialization
;     102 // Clock source: System Clock
;     103 // Clock value: Timer 1 Stopped
;     104 // Mode: Normal top=FFFFh
;     105 // OC1A output: Discon.
;     106 // OC1B output: Discon.
;     107 // Noise Canceler: Off
;     108 // Input Capture on Falling Edge
;     109 TCCR1A=0x00;
	OUT  0x2F,R30
;     110 TCCR1B=0x00;
	OUT  0x2E,R30
;     111 TCNT1H=0x00;
	OUT  0x2D,R30
;     112 TCNT1L=0x00;
	OUT  0x2C,R30
;     113 OCR1AH=0x00;
	OUT  0x2B,R30
;     114 OCR1AL=0x00;
	OUT  0x2A,R30
;     115 OCR1BH=0x00;
	OUT  0x29,R30
;     116 OCR1BL=0x00;
	OUT  0x28,R30
;     117 
;     118 // Timer/Counter 2 initialization
;     119 // Clock source: System Clock
;     120 // Clock value: Timer 2 Stopped
;     121 // Mode: Normal top=FFh
;     122 // OC2 output: Disconnected
;     123 ASSR=0x00;
	OUT  0x22,R30
;     124 TCCR2=0x00;
	OUT  0x25,R30
;     125 TCNT2=0x00;
	OUT  0x24,R30
;     126 OCR2=0x00;
	OUT  0x23,R30
;     127 
;     128 // External Interrupt(s) initialization
;     129 // INT0: Off
;     130 // INT1: Off
;     131 GIMSK=0x00;
	OUT  0x3B,R30
;     132 MCUCR=0x00;
	OUT  0x35,R30
;     133 
;     134 // Timer(s)/Counter(s) Interrupt(s) initialization
;     135 TIMSK=0x00;
	OUT  0x39,R30
;     136 
;     137 // Analog Comparator initialization
;     138 // Analog Comparator: Off
;     139 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     140 // Analog Comparator Output: Off
;     141 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     142 
;     143 //*************************************************
;     144 		for(j=0;j<16;j++)
	LDI  R17,LOW(0)
_0x4:
	CPI  R17,16
	BRSH _0x5
;     145 			bufferfontblocke[15-j]=font[buffernumfont][j];
	RCALL SUBOPT_0x0
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x1
	PUSH R27
	PUSH R26
	RCALL __LSLW4
	POP  R26
	POP  R27
	RCALL SUBOPT_0x2
	POP  R26
	POP  R27
	ST   X,R30
;     146 //-------------------------------------------
;     147 /*		
;     148 		p[0]=font[0][0];			
;     149 		buffernumfont[0]=1;
;     150 		buffernumfont[1]=0;
;     151 */		
;     152 //*************************************************
;     153 /*
;     154 			p[0]=p[0]+buffernumfont[0];
;     155 			for(j=0;j<8;j++)
;     156 			{
;     157 				bufferfontblocke=p[0]+j;
;     158 			}
;     159 */
;     160 
;     161 while (1)
	SUBI R17,-1
	RJMP _0x4
_0x5:
_0x6:
;     162       {
;     163 	refresh();
	RCALL _refresh
;     164 //----------------------control******
;     165    if(i==3)
	CPI  R16,3
	BRNE _0x9
;     166 	{
;     167  	   i=0; 
	LDI  R16,LOW(0)
;     168 	   shifte(1);			
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _shifte
;     169 	   for(k=0;k<3;k++)
	LDI  R18,LOW(0)
_0xB:
	CPI  R18,3
	BRSH _0xC
;     170 	   {
;     171 	      delay();	   	   
	RCALL _delay
;     172 	      refresh();
	RCALL _refresh
;     173 	   }
	SUBI R18,-1
	RJMP _0xB
_0xC:
;     174 	}
;     175 	i++;
_0x9:
	SUBI R16,-1
;     176 //----------------------***********
;     177 	if(numshift==8)
	LDI  R30,LOW(8)
	CP   R30,R5
	BRNE _0xD
;     178 	{
;     179 	   numshift=0;
	CLR  R5
;     180 	   buffernumfont=buffernumfont+1;
	INC  R4
;     181 	   if(buffernumfont>numberfont-1)
	LDI  R30,LOW(3)
	CP   R30,R4
	BRSH _0xE
;     182 	   buffernumfont=0;
	CLR  R4
;     183 	   for(j=0;j<16;j++)
_0xE:
	LDI  R17,LOW(0)
_0x10:
	CPI  R17,16
	BRSH _0x11
;     184 	   {
;     185 	   	bufferfontblocke[15-j]=font[buffernumfont][j];
	RCALL SUBOPT_0x0
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x1
	PUSH R27
	PUSH R26
	RCALL __LSLW4
	POP  R26
	POP  R27
	RCALL SUBOPT_0x2
	POP  R26
	POP  R27
	ST   X,R30
;     186 	   }
	SUBI R17,-1
	RJMP _0x10
_0x11:
;     187 	}
;     188      };
_0xD:
	RJMP _0x6
;     189 }
_0x12:
	RJMP _0x12
;     190 void delay()
;     191 {
_delay:
;     192    char i,j;
;     193    for(i=0;i<25;i++)
	RCALL __SAVELOCR2
;	i -> R16
;	j -> R17
	LDI  R16,LOW(0)
_0x14:
	CPI  R16,25
	BRSH _0x15
;     194    	for(j=0;j<30;j++)
	LDI  R17,LOW(0)
_0x17:
	CPI  R17,30
	BRSH _0x18
;     195 	{}
	SUBI R17,-1
	RJMP _0x17
_0x18:
	SUBI R16,-1
	RJMP _0x14
_0x15:
;     196 }
	RJMP _0x31
;     197 //--------------------------- shifte()
;     198 void shifte(char x)
;     199 {
_shifte:
;     200    unsigned char temps,tempf[16],tempshowfont[3][16];
;     201    unsigned char cx;
;     202    char i,j;
;     203 	numshift=numshift+1;   
	SBIW R28,63
	SBIW R28,1
	RCALL __SAVELOCR4
;	x -> Y+68
;	temps -> R16
;	tempf -> Y+52
;	tempshowfont -> Y+4
;	cx -> R17
;	i -> R18
;	j -> R19
	INC  R5
;     204    for(i=0;i<3;i++)
	LDI  R18,LOW(0)
_0x1A:
	CPI  R18,3
	BRSH _0x1B
;     205    {
;     206 	   for(j=0;j<16;j++)
	LDI  R19,LOW(0)
_0x1D:
	CPI  R19,16
	BRSH _0x1E
;     207    	{
;     208 			tempshowfont[i][j]=buffershowfonte[i][j];
	MOV  R30,R18
	RCALL SUBOPT_0x3
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x4
	PUSH R27
	PUSH R26
	RCALL __LSLW4
	POP  R26
	POP  R27
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
	POP  R26
	POP  R27
	ST   X,R30
;     209 		}
	SUBI R19,-1
	RJMP _0x1D
_0x1E:
;     210 	}	
	SUBI R18,-1
	RJMP _0x1A
_0x1B:
;     211 
;     212 //---------------------------
;     213       for(j=0;j<16;j++)
	LDI  R19,LOW(0)
_0x20:
	CPI  R19,16
	BRSH _0x21
;     214       {
;     215 			 tempf[j]=bufferfontblocke[j];
	RCALL SUBOPT_0x7
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,52
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	POP  R26
	POP  R27
	ST   X,R30
;     216 		}
	SUBI R19,-1
	RJMP _0x20
_0x21:
;     217 //--------------------------- 3===>0000 0111
;     218    cx=1;
	LDI  R17,LOW(1)
;     219    for(i=0;i<x;i++)
	LDI  R18,LOW(0)
_0x23:
	__GETB1SX 68
	CP   R18,R30
	BRSH _0x24
;     220       cx=cx*2;
	LSL  R17
;     221    cx--;
	SUBI R18,-1
	RJMP _0x23
_0x24:
	SUBI R17,1
;     222 //---------------------------
;     223    for(j=0;j<16;j++)
	LDI  R19,LOW(0)
_0x26:
	CPI  R19,16
	BRSH _0x27
;     224    {
;     225       for(i=0;i<=1;i++)
	LDI  R18,LOW(0)
_0x29:
	LDI  R30,LOW(1)
	CP   R30,R18
	BRLO _0x2A
;     226       {
;     227 		 buffershowfonte[i][j]=buffershowfonte[i][j]>>x;
	RCALL SUBOPT_0x4
	PUSH R27
	PUSH R26
	RCALL __LSLW4
	POP  R26
	POP  R27
	RCALL SUBOPT_0x5
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x4
	PUSH R27
	PUSH R26
	RCALL __LSLW4
	POP  R26
	POP  R27
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x9
	POP  R26
	POP  R27
	ST   X,R30
;     228 		 temps=tempshowfont[i+1][j];
	MOV  R30,R18
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0xA
;     229 		 temps=temps&cx;
	AND  R16,R17
;     230 		 temps=temps<<(8-x);
	RCALL SUBOPT_0xB
;     231 		 buffershowfonte[i][j]=buffershowfonte[i][j]|temps;
	RCALL SUBOPT_0x4
	PUSH R27
	PUSH R26
	RCALL __LSLW4
	POP  R26
	POP  R27
	RCALL SUBOPT_0x5
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x4
	PUSH R27
	PUSH R26
	RCALL __LSLW4
	POP  R26
	POP  R27
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
	OR   R30,R16
	POP  R26
	POP  R27
	ST   X,R30
;     232       }
	SUBI R18,-1
	RJMP _0x29
_0x2A:
;     233    }
	SUBI R19,-1
	RJMP _0x26
_0x27:
;     234 
;     235 //--------------------------- for read byte from bufferfontblock
;     236    for(j=0;j<16;j++)
	LDI  R19,LOW(0)
_0x2C:
	CPI  R19,16
	BRSH _0x2D
;     237    {
;     238       buffershowfonte[2][j]=buffershowfonte[2][j]>>x;
	__POINTW2MN _buffershowfonte,32
	RCALL SUBOPT_0x7
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	__POINTW2MN _buffershowfonte,32
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x9
	POP  R26
	POP  R27
	RCALL SUBOPT_0xC
;     239       temps=tempf[j];
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,52
	RCALL SUBOPT_0xA
;     240       temps=temps&cx;
	AND  R16,R17
;     241       temps=temps<<(8-x);
	RCALL SUBOPT_0xB
;     242       buffershowfonte[2][j]=buffershowfonte[2][j]|temps;
	__POINTW2MN _buffershowfonte,32
	RCALL SUBOPT_0x7
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	__POINTW2MN _buffershowfonte,32
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x6
	OR   R30,R16
	POP  R26
	POP  R27
	RCALL SUBOPT_0xC
;     243       bufferfontblocke[j]=bufferfontblocke[j]>>x;
	SUBI R30,LOW(-_bufferfontblocke)
	SBCI R31,HIGH(-_bufferfontblocke)
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	MOV  R26,R30
	__GETB1SX 68
	RCALL __LSRB12
	POP  R26
	POP  R27
	ST   X,R30
;     244    }
	SUBI R19,-1
	RJMP _0x2C
_0x2D:
;     245 }   
	RCALL __LOADLOCR4
	ADIW R28,63
	ADIW R28,6
	RET
;     246 
;     247 void refresh(void)
;     248 {
_refresh:
;     249 	char i,j;
;     250 	for(j=0;j<16;j++)
	RCALL __SAVELOCR2
;	i -> R16
;	j -> R17
	LDI  R17,LOW(0)
_0x2F:
	CPI  R17,16
	BRSH _0x30
;     251 	{
;     252 		PORTB.7=0;
	CBI  0x18,7
;     253 		PORTC=buffershowfonte[0][j];
	RCALL SUBOPT_0xD
	SUBI R30,LOW(-_buffershowfonte)
	SBCI R31,HIGH(-_buffershowfonte)
	LD   R30,Z
	OUT  0x15,R30
;     254 		PORTD.4=1;
	SBI  0x12,4
;     255 		PORTD.4=0;
	CBI  0x12,4
;     256 		PORTC=buffershowfonte[1][j];
	__POINTW2MN _buffershowfonte,16
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6
	OUT  0x15,R30
;     257 		PORTD.5=1;
	SBI  0x12,5
;     258 		PORTD.5=0;
	CBI  0x12,5
;     259 		PORTC=buffershowfonte[2][j];
	__POINTW2MN _buffershowfonte,32
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x6
	OUT  0x15,R30
;     260 		PORTD.6=1;
	SBI  0x12,6
;     261 		PORTD.6=0;
	CBI  0x12,6
;     262 		PORTD=j;
	OUT  0x12,R17
;     263 		delay();
	RCALL _delay
;     264 		delay();
	RCALL _delay
;     265 		PORTB.7=1;
	SBI  0x18,7
;     266 	}
	SUBI R17,-1
	RJMP _0x2F
_0x30:
;     267 }
_0x31:
	RCALL __LOADLOCR2P
	RET
;     268 
;     269 


;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	LDI  R30,LOW(15)
	SUB  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_bufferfontblocke)
	SBCI R31,HIGH(-_bufferfontblocke)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDI  R26,LOW(_font*2)
	LDI  R27,HIGH(_font*2)
	MOV  R30,R4
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM
	MOV  R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDI  R31,0
	RCALL __LSLW4
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,4
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R19
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x4:
	MOV  R30,R18
	LDI  R26,LOW(_buffershowfonte)
	LDI  R27,HIGH(_buffershowfonte)
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x5:
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R19
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x6:
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x7:
	MOV  R30,R19
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	SUBI R30,LOW(-_bufferfontblocke)
	SBCI R31,HIGH(-_bufferfontblocke)
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	__GETB1SX 68
	RCALL __LSRB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	ADD  R26,R30
	ADC  R27,R31
	LD   R16,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	__GETB2SX 68
	LDI  R30,LOW(8)
	SUB  R30,R26
	MOV  R26,R16
	RCALL __LSLB12
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	ST   X,R30
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xD:
	MOV  R30,R17
	LDI  R31,0
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSRB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSRB12R
__LSRB12L:
	LSR  R30
	DEC  R0
	BRNE __LSRB12L
__LSRB12R:
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
