/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.8d Professional
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : SMS Controller
Version : 
Date    : 1/1/2002
Author  : Mohammad                            
Company : Griffin                            
Comments: 


Chip type           : ATmega32
Program type        : Application
Clock frequency     : 4.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 512
*****************************************************/

#include <mega32.h>
#include <string.h>  
#include <stdio.h>
#include <stdlib.h>
#include <delay.h>
#include <math.h>  
//#include "MtoS.c"
#include <stdio.h>
// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15 ;PORTC
#endasm
#include <lcd.h>

#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)    


#define msg_MAX 350
                   
#define Phone 0
#define Simcard 1

  

unsigned int index=0;

flash char n1[1][13]={"09153174784"};  



int senderNoLength, messageLength;   

unsigned char senderNo[14];
unsigned char msg_read_buffer[180]= {0};

char des_no_buffer[12]="0912";
char msg_send_buffer[160]="Salam";


unsigned char i,j;
unsigned char state;

// USART Receiver buffer
#define RX_BUFFER_SIZE 350
char rx_buffer[RX_BUFFER_SIZE];

#if RX_BUFFER_SIZE<256
unsigned char rx_wr_index,rx_rd_index,rx_counter;
#else
unsigned int rx_wr_index,rx_rd_index,rx_counter;
#endif

// This flag is set on USART Receiver buffer overflow
bit rx_buffer_overflow;
                            



void decode_PDU(unsigned char* input,unsigned int ch_1st);
unsigned char intvalue(char ch);
unsigned int find_pdu_st(unsigned char* input);  
void read_msg(unsigned char msg_no); 
void send_msg(void);
void delet_msg(unsigned char msg_no);
void msg_memory_set(unsigned char); 
char* encode_PDU(unsigned char* inputMsg);
char wait_resp(void); 
void recharge(char* input_code);
unsigned char asciiValue(char);


void clear_rx_buffer(void);
void phone_init(void);
void micro_init(void);



/////////////////////////////////////////////////
/////////////////////////////////////////////////

// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;

if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
   rx_buffer[rx_wr_index]=data;
   if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
   if (++rx_counter == RX_BUFFER_SIZE)
      {
      rx_counter=0;
      rx_buffer_overflow=1;
      };
   };
}

#ifndef _DEBUG_TERMINAL_IO_
// Get a character from the USART Receiver buffer
#define _ALTERNATE_GETCHAR_
#pragma used+
char getchar(void)
{
char data;
while (rx_counter==0);
data=rx_buffer[rx_rd_index];
if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
#asm("cli")
--rx_counter;
#asm("sei")
return data;
}
#pragma used-
#endif                                           

/////////////////////////////////////////////////
/////////////////////////////////////////////////


enum
{
       State_Ringing,
       State_Calling,
       State_Msg_Received,
       State_Msg_Sending
       //STATE_MENU
};
/////////////////////////////////////////////////////////////////////////////////////////////////////////
void main(void)
{     



micro_init();

//phone_init();
//printf("at+csca=\"+9891100500\"\r");  
//delay_ms(1000);
//send_msg();
//while(strcmp(ok_str,end_buffer)!=0) 


//printf("at+cmer=3,0,2,0,0\r");
                                
 // VTS


//printf("at+cclk=\"07/10/20,10:40:00\"\r");
//read_date();
// 
//lear_rx_buffer();
//printf("AT*ECAM=1\r");
//while(wait_resp()!=0); 




   
    
/*while(wait_resp()!=0);
printf("at+ckpd=\"1\"\r");
while(wait_resp()!=0);
printf("at+ckpd=\"#\"\r"); 
while(wait_resp()!=0);
printf("at+ckpd=\"S\"\r");
  */ 
  //for(index=0;index<200;index++)
//         send_msg();
//clear_rx_buffer();
//read_msg(1); 

//while(wait_resp()!=0);  
//recharge(msg_send_buffer);
        send_msg();
while (1)
      {
        
      };
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////
///////////////////////////////////////// 
void delet_msg(unsigned char msg_no)
{       
        char str[2];
        clear_rx_buffer();
        itoa(msg_no,str);            
        printf("AT+CMGD=%s\r",str);
        while(wait_resp()!=0);  
}
/////////////////////////////////////////
///////////////////////////////////////// 

void read_msg(unsigned char msg_no)
{       
        char str[2];
        clear_rx_buffer();
        itoa(msg_no,str);
        printf("AT+CMGR=%s\r",str);  
        while(wait_resp()!=0);
        decode_PDU(rx_buffer,find_pdu_st(rx_buffer));    

}  
/////////////////////////////////////////
/////////////////////////////////////////
void send_msg()
{       
        char str[2],encoded_des_no[11],send_buffer[200]="0001000C9189",send_temp[5]="0000";
       
        int i,pdu_len;
        for(i=0;i<11;i++)
        {
                if(fmod(i,2)==0)    
                {
                     encoded_des_no[i]=des_no_buffer[i+2];   
                }
                else if (fmod(i,2)==1)
                {
                        encoded_des_no[i]=des_no_buffer[i];
                }
        } 
        
        strncat(send_buffer,encoded_des_no,10);
        strncat(send_buffer,send_temp,4);
        strcat(send_buffer,encode_PDU(msg_send_buffer));
        pdu_len=(strlen(send_buffer)-2)/2;
        while(1)
        {
        clear_rx_buffer();
        itoa(pdu_len,str);
        printf("AT+CMGS=%s\r",str);
        while(strstrf(rx_buffer,">")==0);
               
        
        printf("%s\x1A",send_buffer);
        
        if(wait_resp()==0)
                return;
        
        }           
        
        
}
/////////////////////////////////////////
/////////////////////////////////////////
void msg_memory_set(unsigned char memory_unit)
{ 
        if(memory_unit==0)
                printf("AT+CPMS=\"ME\"\r"); 
        else if(memory_unit==1)
                printf("AT+CPMS=\"SM\"\r");

}
 
/////////////////////////////////////////
/////////////////////////////////////////
void phone_init(void)
{       
        
        clear_rx_buffer();
        do
                msg_memory_set(Phone);     /// select memory storage
        while(wait_resp()!=0);
        
        clear_rx_buffer();
        do
                printf("AT+CNMI=3,1,2,0\r");   ////enable msg reporting
        while(wait_resp()!=0);
        
        clear_rx_buffer();
        do                                   
                printf("AT*ESIL=1\r");      /// enable silent mode
        while(wait_resp()!=0); 
        
        clear_rx_buffer();
        do                                   
                printf("AT*ECAM=1\r");      /// enable call monitoring
        while(wait_resp()!=0);          

}  
/////////////////////////////////////////
/////////////////////////////////////////  

/////////////////////////////////////////
/////////////////////////////////////////  

char wait_resp(void)
{
        while(1)
        {       
                
                if (strstrf(rx_buffer,"OK")!=0)
                        return 0;
                else  if (strstrf(rx_buffer,"ERROR")!=0)   
                        return 1;
                
        };
        return 1;

}  
/////////////////////////////////////////
/////////////////////////////////////////
void clear_rx_buffer(void)
{             
        int i;
        for(i=0;i<RX_BUFFER_SIZE+1;i++)
                rx_buffer[i]=0;   
        rx_wr_index=0;
        
} 
/////////////////////////////////////////
/////////////////////////////////////////   

void recharge(char* input_code)
{       
        clear_rx_buffer();      
        printf("AT+CKPD=\"ee*140*%s#s\"\r",input_code);
        while(wait_resp()!=0);
}
/////////////////////////////////////////
/////////////////////////////////////////  
char* encode_PDU(unsigned char* inputMsg)
{
     int i=0,j=0;
    char encodedMsg [100];
    char stringEncodedMsg [200];
    unsigned char bitsToTransfer = 0x7F,shiftCount = 6,nextVal;
    nextVal=inputMsg[0];
    while ((inputMsg[i] > 0)) 
    {
        
        bitsToTransfer = bitsToTransfer >> shiftCount;
        bitsToTransfer = bitsToTransfer &  inputMsg[i+1];
        bitsToTransfer = bitsToTransfer << (shiftCount+1);
        encodedMsg [ j++ ] = nextVal | bitsToTransfer;
        nextVal =  inputMsg [ i+1 ] >> (7 - shiftCount);
        shiftCount--;
        i++;
        bitsToTransfer = 0xFF;
        if( ((i % 8) == 7) && (inputMsg[i+1]>0)) 
        {
            shiftCount = 6;
            i++;
            nextVal=inputMsg[i];
        }
    }       
    stringEncodedMsg[1]=asciiValue(i%16);
    if (i<16)         
        stringEncodedMsg[0]=48;
    else 
        stringEncodedMsg[0]=asciiValue(i/16);
    for( i=1; i < j+1; i++)
    {
        stringEncodedMsg [ 2*i ] = encodedMsg [ i-1 ] & 0xF0; 
        stringEncodedMsg [ 2*i ] = stringEncodedMsg [ 2*i ] >> 4;  
        stringEncodedMsg [ 2*i ] &= 0x0F;
        stringEncodedMsg [ 2*i ] = asciiValue(stringEncodedMsg [ 2*i ]); 
        stringEncodedMsg [ 2*i+1 ] = encodedMsg [ i-1 ] & 0x0F; 
        stringEncodedMsg [ 2*i+1 ] = asciiValue(stringEncodedMsg [ 2*i+1 ]);
    }



    return  stringEncodedMsg;


    return  stringEncodedMsg;

}

//////////////////////////////////
//////////////////////////////////  

unsigned char asciiValue(char ch)
{
    switch (ch) 
    {
    case 0:
        return 48;
    case 1:
        return 49;
    case 2:
        return 50;
    case 3:
        return 51;
    case 4:
        return 52;
    case 5:
        return 53; 
    case 6:
        return 54;
    case 7:
        return 55;
    case 8:
        return 56;
    case 9:
        return 57;
    case 10:
        return 65;
    case 11:
        return 66; 
    case 12:
        return 67;
    case 13:
        return 68;
    case 14:
        return 69;
    case 15:
        return 70;
    default:
        break;
    }
    return -1;
}  
  
/////////////////////////
/////////////////////////
void decode_PDU(unsigned char* input,unsigned int pdu_start)
{
	int useless ,septetBtytesNo,RemainBytesNo,charMessageLength;
	int i,j;
	unsigned char lastValue;
	unsigned char tempMsg[180]= {0};   
	unsigned char dateTime[14];       
	
	useless=2+pdu_start;
	
	useless += (((int)intvalue(input[0+pdu_start])*10 + intvalue(input[1+pdu_start]))*2);
	useless +=2;
	senderNoLength = ((int) intvalue(input[useless])*10 + intvalue(input[useless+1])) ; 
	if(senderNoLength == 12 )
	{
	        useless+=6;        
	        senderNo[0]='0';
	        senderNoLength-=2;
	}
	else useless+=4;
	for(i = 0; i <= senderNoLength-2; i+=2)
	{
		senderNo[i+2] = intvalue(input[useless+i])+48;
		senderNo[i+1] = intvalue(input[useless+i+1])+48;
	}
	if((senderNoLength%2)== 1)
	{
		senderNo[i] = intvalue(input[useless+i+1])+48;
		useless += senderNoLength + 1 + 4;
	}
	else
		useless += senderNoLength + 4;

	for(i = 0; i < 12; i+=2)
	{
		dateTime[i+1] = intvalue(input[useless+i])+48;
		dateTime[i] = intvalue(input[useless+i+1])+48;
	}
	//timeZone = (((int)dateTime[12]*10) + dateTime[13]);
	useless += 14;
	messageLength = ((int) intvalue(input[useless])*10 + intvalue(input[useless+1])) ;
	charMessageLength = (messageLength - (messageLength/7))*2;
	useless += 2;
	for (i=0, j=0; i < charMessageLength; i+=2, j++)
	{
		tempMsg[j] = intvalue(input[useless +i]);
		tempMsg[j] = (tempMsg[j] << 4);
		tempMsg[j] = (tempMsg [j] | intvalue(input[useless+i+1]));
	}
	septetBtytesNo = messageLength / 7;
	RemainBytesNo = (messageLength % 7) - (messageLength/7);
	for (i= 0; i < septetBtytesNo; i++)
	{
		lastValue = 0x00;
		for( j= 6; j >= 0; j--)
		{
			msg_read_buffer[(i*8)+j+1] = (((tempMsg[(i*7) +  j]) >> (7 - j)) | lastValue) ;
			lastValue = 0xFF;
			lastValue = lastValue >> (j+1);
			lastValue = lastValue & tempMsg[(i*7) + j];
			lastValue = lastValue << (j);
		}
		msg_read_buffer[(i*8)] = (tempMsg[(i*7)] & 0x7F);
	}
	j = RemainBytesNo -1;
	lastValue = 0xFF;
	lastValue = lastValue >> (j+1);
	lastValue = lastValue & tempMsg[(septetBtytesNo*7) + j];
	lastValue = lastValue << (j);
	for( j = RemainBytesNo -1-1 ; j >= 0; j--)
	{
		msg_read_buffer[(septetBtytesNo*8)+j+1] = (((tempMsg[(septetBtytesNo*7) +  j]) >> (7 - j)) | lastValue) ;
		lastValue = 0xFF;
		lastValue = lastValue >> (j+1);
		lastValue = lastValue & tempMsg[(septetBtytesNo*7) + j];
		lastValue = lastValue << (j);
	}
	msg_read_buffer[(septetBtytesNo*8)] = (tempMsg[(septetBtytesNo*7)] & 0x7F);

}
//////////////////////////////////
//////////////////////////////////
unsigned char intvalue(char ch)
{
	switch (ch)
	{
	case 48:
		return 0;
	case 49:
		return 1;
	case 50:
		 return 2;
	case 51:
		return 3;
	case 52:
		return 4;
	case 53:
		return 5; 
	case 54:
		return 6;
	case 55:
		return 7;
	case 56:
		return 8;
	case 57:
		return 9;
	case 65:
		return 10;
	case 66:
		return 11;
	case 67:
		return 12;
	case 68:
		return 13;
	case 69:
		return 14;
	case 70:
		return 15;
	default:
		break;
	}
	return -1;
}


/////////////////////////////////////////
/////////////////////////////////////////
unsigned int find_pdu_st(unsigned char* input)
{
        unsigned i,j=0;
        for(i=0;i<msg_MAX;i++)
        {
                if(input[i]==13) 
                {
                        if (j==2)     
                        {
                                return i+2;
                                break;
                        }
                                j++;
                }
                
        }
}
/////////////////////////////////////////
/////////////////////////////////////////

void micro_init(void)
{              
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;


// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 9600
UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// LCD module initialization
lcd_init(16);

// Global enable interrupts
#asm("sei")
}