/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.8d Professional
Automatic Program Generator
 Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : SMS Controller
Version : 
Date    : 1/1/2002
Author  : Mohammad                            
Company : Griffin                            
Comments: 


Chip type           : ATmega32
Program type        : Application
Clock frequency     : 4.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 512
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega32


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADCSR=6;     // for compatibility with older code
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


// CodeVisionAVR C Compiler
// (C) 1998-2007 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for string functions



#pragma used+
#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);
 
unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib


// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;
typedef char *va_list;
typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


/* CodeVisionAVR C Compiler
   Prototypes for standard library functions

   (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+
#pragma used+

int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

/*
CodeVisionAVR C Compiler
Prototypes for mathematical functions

Portions (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L.
Portions (C) 2000-2001 Yuri G. Salov
*/



#pragma used+
#pragma used+

unsigned char cabs(signed char x);
unsigned int abs(int x);
unsigned long labs(long x);
float fabs(float x);
signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib


//#include "MtoS.c"
// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions












                                   

            





// Alphanumeric LCD Module functions
#asm
#asm
   .equ __lcd_port=0x15 ;PORTC
#endasm
/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+
#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib






                   

  

unsigned int index=0;

flash char n1[1][13]={"09153174784"};  



int senderNoLength, messageLength;   

unsigned char senderNo[14];
unsigned char msg_read_buffer[180]= {0};

char des_no_buffer[12]="0912";
char msg_send_buffer[160]="Salam";


unsigned char i,j;
unsigned char state;

// USART Receiver buffer
char rx_buffer[350];

unsigned int rx_wr_index,rx_rd_index,rx_counter;

// This flag is set on USART Receiver buffer overflow
bit rx_buffer_overflow;
                            



void decode_PDU(unsigned char* input,unsigned int ch_1st);
unsigned char intvalue(char ch);
unsigned int find_pdu_st(unsigned char* input);  
void read_msg(unsigned char msg_no); 
void send_msg(void);
void delet_msg(unsigned char msg_no);
void msg_memory_set(unsigned char); 
char* encode_PDU(unsigned char* inputMsg);
char wait_resp(void); 
void recharge(char* input_code);
unsigned char asciiValue(char);


void clear_rx_buffer(void);
void phone_init(void);
void micro_init(void);



/////////////////////////////////////////////////
/////////////////////////////////////////////////

// USART Receiver interrupt service routine
interrupt [14] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;

if ((status & ((1<<4) | (1<<2) | (1<<3)))==0)
   {
   rx_buffer[rx_wr_index]=data;
   if (++rx_wr_index == 350) rx_wr_index=0;
   if (++rx_counter == 350)
      {
      rx_counter=0;
      rx_buffer_overflow=1;
      };
   };
}

// Get a character from the USART Receiver buffer
#pragma used+
char getchar(void)
{
char data;
while (rx_counter==0);
data=rx_buffer[rx_rd_index];
if (++rx_rd_index == 350) rx_rd_index=0;
#asm("cli")
--rx_counter;
#asm("sei")
return data;
}
#pragma used-

/////////////////////////////////////////////////
/////////////////////////////////////////////////


enum
{
       State_Ringing,
       State_Calling,
       State_Msg_Received,
       State_Msg_Sending
       //STATE_MENU
};
/////////////////////////////////////////////////////////////////////////////////////////////////////////
void main(void)
{     



micro_init();

//phone_init();
//printf("at+csca=\"+9891100500\"\r");  
//delay_ms(1000);
//send_msg();
//while(strcmp(ok_str,end_buffer)!=0) 


//printf("at+cmer=3,0,2,0,0\r");
                                
 // VTS


//printf("at+cclk=\"07/10/20,10:40:00\"\r");
//read_date();
// 
//lear_rx_buffer();
//printf("AT*ECAM=1\r");
//while(wait_resp()!=0); 




   
    
/*while(wait_resp()!=0);
printf("at+ckpd=\"1\"\r");
while(wait_resp()!=0);
printf("at+ckpd=\"#\"\r"); 
while(wait_resp()!=0);
printf("at+ckpd=\"S\"\r");
  */ 
  //for(index=0;index<200;index++)
//         send_msg();
//clear_rx_buffer();
//read_msg(1); 

//while(wait_resp()!=0);  
//recharge(msg_send_buffer);
        send_msg();
while (1)
      {
        
      };
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////
///////////////////////////////////////// 
void delet_msg(unsigned char msg_no)
{       
        char str[2];
        clear_rx_buffer();
        itoa(msg_no,str);            
        printf("AT+CMGD=%s\r",str);
        while(wait_resp()!=0);  
}
/////////////////////////////////////////
///////////////////////////////////////// 

void read_msg(unsigned char msg_no)
{       
        char str[2];
        clear_rx_buffer();
        itoa(msg_no,str);
        printf("AT+CMGR=%s\r",str);  
        while(wait_resp()!=0);
        decode_PDU(rx_buffer,find_pdu_st(rx_buffer));    

}  
/////////////////////////////////////////
/////////////////////////////////////////
void send_msg()
{       
        char str[2],encoded_des_no[11],send_buffer[200]="0001000C9189",send_temp[5]="0000";
       
        int i,pdu_len;
        for(i=0;i<11;i++)
        {
                if(fmod(i,2)==0)    
                {
                     encoded_des_no[i]=des_no_buffer[i+2];   
                }
                else if (fmod(i,2)==1)
                {
                        encoded_des_no[i]=des_no_buffer[i];
                }
        } 
        
        strncat(send_buffer,encoded_des_no,10);
        strncat(send_buffer,send_temp,4);
        strcat(send_buffer,encode_PDU(msg_send_buffer));
        pdu_len=(strlen(send_buffer)-2)/2;
        while(1)
        {
        clear_rx_buffer();
        itoa(pdu_len,str);
        printf("AT+CMGS=%s\r",str);
        while(strstrf(rx_buffer,">")==0);
               
        
        printf("%s\x1A",send_buffer);
        
        if(wait_resp()==0)
                return;
        
        }           
        
        
}
/////////////////////////////////////////
/////////////////////////////////////////
void msg_memory_set(unsigned char memory_unit)
{ 
        if(memory_unit==0)
                printf("AT+CPMS=\"ME\"\r"); 
        else if(memory_unit==1)
                printf("AT+CPMS=\"SM\"\r");

}
 
/////////////////////////////////////////
/////////////////////////////////////////
void phone_init(void)
{       
        
        clear_rx_buffer();
        do
                msg_memory_set(0);     /// select memory storage
        while(wait_resp()!=0);
        
        clear_rx_buffer();
        do
                printf("AT+CNMI=3,1,2,0\r");   ////enable msg reporting
        while(wait_resp()!=0);
        
        clear_rx_buffer();
        do                                   
                printf("AT*ESIL=1\r");      /// enable silent mode
        while(wait_resp()!=0); 
        
        clear_rx_buffer();
        do                                   
                printf("AT*ECAM=1\r");      /// enable call monitoring
        while(wait_resp()!=0);          

}  
/////////////////////////////////////////
/////////////////////////////////////////  

/////////////////////////////////////////
/////////////////////////////////////////  

char wait_resp(void)
{
        while(1)
        {       
                
                if (strstrf(rx_buffer,"OK")!=0)
                        return 0;
                else  if (strstrf(rx_buffer,"ERROR")!=0)   
                        return 1;
                
        };
        return 1;

}  
/////////////////////////////////////////
/////////////////////////////////////////
void clear_rx_buffer(void)
{             
        int i;
        for(i=0;i<350+1;i++)
                rx_buffer[i]=0;   
        rx_wr_index=0;
        
} 
/////////////////////////////////////////
/////////////////////////////////////////   

void recharge(char* input_code)
{       
        clear_rx_buffer();      
        printf("AT+CKPD=\"ee*140*%s#s\"\r",input_code);
        while(wait_resp()!=0);
}
/////////////////////////////////////////
/////////////////////////////////////////  
char* encode_PDU(unsigned char* inputMsg)
{
     int i=0,j=0;
    char encodedMsg [100];
    char stringEncodedMsg [200];
    unsigned char bitsToTransfer = 0x7F,shiftCount = 6,nextVal;
    nextVal=inputMsg[0];
    while ((inputMsg[i] > 0)) 
    {
        
        bitsToTransfer = bitsToTransfer >> shiftCount;
        bitsToTransfer = bitsToTransfer &  inputMsg[i+1];
        bitsToTransfer = bitsToTransfer << (shiftCount+1);
        encodedMsg [ j++ ] = nextVal | bitsToTransfer;
        nextVal =  inputMsg [ i+1 ] >> (7 - shiftCount);
        shiftCount--;
        i++;
        bitsToTransfer = 0xFF;
        if( ((i % 8) == 7) && (inputMsg[i+1]>0)) 
        {
            shiftCount = 6;
            i++;
            nextVal=inputMsg[i];
        }
    }       
    stringEncodedMsg[1]=asciiValue(i%16);
    if (i<16)         
        stringEncodedMsg[0]=48;
    else 
        stringEncodedMsg[0]=asciiValue(i/16);
    for( i=1; i < j+1; i++)
    {
        stringEncodedMsg [ 2*i ] = encodedMsg [ i-1 ] & 0xF0; 
        stringEncodedMsg [ 2*i ] = stringEncodedMsg [ 2*i ] >> 4;  
        stringEncodedMsg [ 2*i ] &= 0x0F;
        stringEncodedMsg [ 2*i ] = asciiValue(stringEncodedMsg [ 2*i ]); 
        stringEncodedMsg [ 2*i+1 ] = encodedMsg [ i-1 ] & 0x0F; 
        stringEncodedMsg [ 2*i+1 ] = asciiValue(stringEncodedMsg [ 2*i+1 ]);
    }



    return  stringEncodedMsg;


    return  stringEncodedMsg;

}

//////////////////////////////////
//////////////////////////////////  

unsigned char asciiValue(char ch)
{
    switch (ch) 
    {
    case 0:
        return 48;
    case 1:
        return 49;
    case 2:
        return 50;
    case 3:
        return 51;
    case 4:
        return 52;
    case 5:
        return 53; 
    case 6:
        return 54;
    case 7:
        return 55;
    case 8:
        return 56;
    case 9:
        return 57;
    case 10:
        return 65;
    case 11:
        return 66; 
    case 12:
        return 67;
    case 13:
        return 68;
    case 14:
        return 69;
    case 15:
        return 70;
    default:
        break;
    }
    return -1;
}  
  
/////////////////////////
/////////////////////////
void decode_PDU(unsigned char* input,unsigned int pdu_start)
{
	int useless ,septetBtytesNo,RemainBytesNo,charMessageLength;
	int i,j;
	unsigned char lastValue;
	unsigned char tempMsg[180]= {0};   
	unsigned char dateTime[14];       
	
	useless=2+pdu_start;
	
	useless += (((int)intvalue(input[0+pdu_start])*10 + intvalue(input[1+pdu_start]))*2);
	useless +=2;
	senderNoLength = ((int) intvalue(input[useless])*10 + intvalue(input[useless+1])) ; 
	if(senderNoLength == 12 )
	{
	        useless+=6;        
	        senderNo[0]='0';
	        senderNoLength-=2;
	}
	else useless+=4;
	for(i = 0; i <= senderNoLength-2; i+=2)
	{
		senderNo[i+2] = intvalue(input[useless+i])+48;
		senderNo[i+1] = intvalue(input[useless+i+1])+48;
	}
	if((senderNoLength%2)== 1)
	{
		senderNo[i] = intvalue(input[useless+i+1])+48;
		useless += senderNoLength + 1 + 4;
	}
	else
		useless += senderNoLength + 4;

	for(i = 0; i < 12; i+=2)
	{
		dateTime[i+1] = intvalue(input[useless+i])+48;
		dateTime[i] = intvalue(input[useless+i+1])+48;
	}
	//timeZone = (((int)dateTime[12]*10) + dateTime[13]);
	useless += 14;
	messageLength = ((int) intvalue(input[useless])*10 + intvalue(input[useless+1])) ;
	charMessageLength = (messageLength - (messageLength/7))*2;
	useless += 2;
	for (i=0, j=0; i < charMessageLength; i+=2, j++)
	{
		tempMsg[j] = intvalue(input[useless +i]);
		tempMsg[j] = (tempMsg[j] << 4);
		tempMsg[j] = (tempMsg [j] | intvalue(input[useless+i+1]));
	}
	septetBtytesNo = messageLength / 7;
	RemainBytesNo = (messageLength % 7) - (messageLength/7);
	for (i= 0; i < septetBtytesNo; i++)
	{
		lastValue = 0x00;
		for( j= 6; j >= 0; j--)
		{
			msg_read_buffer[(i*8)+j+1] = (((tempMsg[(i*7) +  j]) >> (7 - j)) | lastValue) ;
			lastValue = 0xFF;
			lastValue = lastValue >> (j+1);
			lastValue = lastValue & tempMsg[(i*7) + j];
			lastValue = lastValue << (j);
		}
		msg_read_buffer[(i*8)] = (tempMsg[(i*7)] & 0x7F);
	}
	j = RemainBytesNo -1;
	lastValue = 0xFF;
	lastValue = lastValue >> (j+1);
	lastValue = lastValue & tempMsg[(septetBtytesNo*7) + j];
	lastValue = lastValue << (j);
	for( j = RemainBytesNo -1-1 ; j >= 0; j--)
	{
		msg_read_buffer[(septetBtytesNo*8)+j+1] = (((tempMsg[(septetBtytesNo*7) +  j]) >> (7 - j)) | lastValue) ;
		lastValue = 0xFF;
		lastValue = lastValue >> (j+1);
		lastValue = lastValue & tempMsg[(septetBtytesNo*7) + j];
		lastValue = lastValue << (j);
	}
	msg_read_buffer[(septetBtytesNo*8)] = (tempMsg[(septetBtytesNo*7)] & 0x7F);

}
//////////////////////////////////
//////////////////////////////////
unsigned char intvalue(char ch)
{
	switch (ch)
	{
	case 48:
		return 0;
	case 49:
		return 1;
	case 50:
		 return 2;
	case 51:
		return 3;
	case 52:
		return 4;
	case 53:
		return 5; 
	case 54:
		return 6;
	case 55:
		return 7;
	case 56:
		return 8;
	case 57:
		return 9;
	case 65:
		return 10;
	case 66:
		return 11;
	case 67:
		return 12;
	case 68:
		return 13;
	case 69:
		return 14;
	case 70:
		return 15;
	default:
		break;
	}
	return -1;
}


/////////////////////////////////////////
/////////////////////////////////////////
unsigned int find_pdu_st(unsigned char* input)
{
        unsigned i,j=0;
        for(i=0;i<350;i++)
        {
                if(input[i]==13) 
                {
                        if (j==2)     
                        {
                                return i+2;
                                break;
                        }
                                j++;
                }
                
        }
}
/////////////////////////////////////////
/////////////////////////////////////////

void micro_init(void)
{              
// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;


// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 9600
UCSRA=0x00;
UCSRB=0x98;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// LCD module initialization
lcd_init(16);

// Global enable interrupts
#asm("sei")
}
