'-------------------------------------------------------------------------------
' Filename    : RC5_Receive.bas
' Purpose     : RC5 IR Remote Control Receiver
' Version     : 1.0
' Support Mail: r.shamss@gmail.com
' Author      : R. Shams
' Controller  : ATMega8
' Compiler    : BASCOM-AVR   Rev. 1.11.7.4
'-------------------------------------------------------------------------------
$regfile = "m8def.dat"
$crystal = 1000000
'
Dim Address As Byte , Command As Byte , State As Byte , Sel As Byte
'
Config Rc5 = Pind.7
Config Portb = &B00011110
Config Portc = &B00011110
Config Pind.6 = Output
'
Enable Interrupts
'
Main:
   Portd.6 = 0
   Do
      Getrc5(address , Command)
   Loop Until Address = 13
   Portd.6 = 1
   If Command = State Then Goto Main
   State = Command
   Command = Command And &B01111111
   Select Case Command
      Case 41 : Sel = 1
      Case 14 : Sel = 2
      Case 53 : Sel = 3
      Case 18 : Sel = 4
   End Select
   Toggle Portb.sel
   Toggle Portc.sel
Goto Main
'
End                                                         'end program