$regfile = "m16def.dat"
$crystal = 8000000
'$sim
'config------------------------
Config Portc = Output
Config Portd = Input
Config Pina.0 = Output , Pina.1 = Output , Pina.2 = Output , Pina.3 = Output
Config Pina.4 = Output , Pina.5 = Input , Pinb.4 = Input , Pinb.0 = Output
Config Adc = Single , Prescaler = Auto , Reference = Avcc
Config Int0 = Rising
Config Int1 = Rising
Beep Alias Portb.0
Clr1 Alias Pinb.4
Add1 Alias Pind.0
Check1 Alias Pind.6
Set Portb.4 : Set Portd.0 : Set Portd.6 : Reset Portd.1 : Reset Portd.2 : Reset Portd.3
Enable Interrupts
On Int0 Int0routine
On Int1 Int1routine
'Dim---------------------------
Dim Count1 As Byte
Dim Count2 As Byte
Dim Count3 As Byte
Dim Count4 As Byte
Dim Count5 As Byte
Dim Gb2 As Byte
Dim Gb4 As Byte
Dim Seg1 As Byte
Dim Seg2 As Byte
Dim Seg3 As Byte
Dim Seg4 As Byte
Dim Seg5 As Byte
Dim E2pointer As Byte
Dim Chpointer As Byte
Dim E2pointeree As Eram Byte
Dim Gb As Word
Dim Gb1 As Word
Dim Seg As Long
Dim Sega As Long
Dim Calibnum As Long
Dim Sum As Long
Dim Sum1 As Long
Dim Adcval As Long
Dim Calibnumee As Eram Long
Dim E2(100) As Eram Long
Dim Segstr As String * 5
Dim Segstr1 As String * 1
Dim Segstr2 As String * 1
Dim Segstr3 As String * 1
Dim Segstr4 As String * 1
Dim Segstr5 As String * 1
Dim Adcstring As String * 4
Dim Adcstg As String * 1



Declare Sub Lo1 , Batt , Show , Blank , Calib , G0 , Rated , Show00000 , Added , Over
Declare Sub Showsega , Sumequal , Clear , A100m , Press , Check , After , E2number

'MAIN--------------------------
Main:
$asm
ldi r16,$04
Out Sph , R16
ldi r16,$5f
Out Spl , R16
$end Asm

Enable Interrupts
Count1 = 0 : Count2 = 0 : Count3 = 0 : Count4 = 0 : Count5 = 0 : Sum = 0
Seg = 0 : Seg1 = 0 : Seg2 = 0 : Seg3 = 0 : Seg4 = 0 : Seg5 = 0 : Chpointer = 0

Start Adc
Porta = &B11111110
Portc = &B00000000
Waitms 50
Adcval = Getadc(5)
Adcval = Adcval * 100
Stop Adc

Select Case Adcval
    Case Is < 52000 : Adcval = Adcval / 778                 '   <6.7V
    Case 52000 To 55499 : Adcval = Adcval / 758             '6.7V to 7.2V
    Case 55500 To 60899 : Adcval = Adcval / 760             '7.2V to 8V
    Case 60900 To 74399 : Adcval = Adcval / 749             '8V to 10V
    Case 74400 To 87899 : Adcval = Adcval / 735             '10V to 12V
    Case Is => 87900 : Adcval = Adcval / 722                '   >12V
End Select

If Adcval > 99 Then
Adcstring = Str(adcval)
Adcstg = Mid(adcstring , 1 , 1)
Count3 = Val(adcstg)
Adcstg = Mid(adcstring , 2 , 1)
Count2 = Val(adcstg)
Adcstg = Mid(adcstring , 3 , 1)
Count1 = Val(adcstg)
Else
Adcstring = Str(adcval)
Adcstg = Mid(adcstring , 1 , 1)
Count2 = Val(adcstg)
Adcstg = Mid(adcstring , 2 , 1)
Count1 = Val(adcstg)
End If

Gb1 = 200
Gosub Show

Select Case Adcval
   Case Is =< 67
       Gb1 = 250
       Gosub Lo1
       Gosub Blank
       Gosub Batt
       Gosub Blank
       Gosub Turn
       Gosub Blank
       Gosub Off1

   Case 68 To 72
      Gb1 = 250
      Gosub Lo1
      Gosub Blank
      Gosub Batt
      Gosub Blank
   Case Else
End Select


Count1 = 0 : Count2 = 0 : Count3 = 0 : Count4 = 0 : Count5 = 0 : Sum = 0

If Clr1 = 0 And Check1 = 0 And Add1 = 0 Then
Gosub Calibrate
End If

E2pointer = E2pointeree
If E2pointer = 0 Then
   Gb1 = 400
   Gosub Clear
Else
   Gb1 = 300
   Gosub E2number
End If

Count1 = 0 : Count2 = 0 : Count3 = 0 : Count4 = 0 : Count5 = 0 : Sum = 0
Calibnum = Calibnumee

Enable Int0
Do
Start1:
'-----------------clr press-------------

If Clr1 = 1 Then
   Goto A1
Else
   Waitms 5
   Sum1 = 0
A2:
   Sum1 = Sum1 + 1
   If Sum1 > 350000 Then Goto A11                           '5 sec.

   If Clr1 = 0 Then Goto A2
   Disable Int0
   Chpointer = 0
   Count1 = 0 : Count2 = 0 : Count3 = 0 : Count4 = 0 : Count5 = 0 : Sum = 0
   Enable Int0
End If

'-----------------add press-------------

A1:
If Add1 = 1 Then
   Goto A3
Else
   Waitms 5
A4:
   If Add1 = 0 Then Goto A4
   Disable Int0
   E2pointer = E2pointeree
   If E2pointer < 100 Then
      If Sum = 0 Then
         Enable Int0
         Goto A3
      End If
      E2pointer = E2pointer + 1
      E2(e2pointer) = Seg
      Gb1 = 250
      Gosub Added
      E2pointeree = E2pointer
      Count1 = 0 : Count2 = 0 : Count3 = 0 : Count4 = 0 : Count5 = 0 : Sum = 0
   Else
      Gb1 = 350
      Gosub Over
   End If
   Enable Int0
End If


'----------------check press------------
A3:
If Check1 = 1 Then
   Goto A5
Else                                                        'check pressed

   Waitms 5
A6:
   If Check1 = 0 Then Goto A6                               ' Wait Until Release
   Waitms 5
   E2pointer = E2pointeree
   If E2pointer = 0 Then Goto A5
   Disable Int0
   E2pointer = E2pointeree
   If E2pointer <> 0 Then
A8:
      Chpointer = Chpointer + 1
      Sega = E2(chpointer)
A7:
      Gosub Showsega                                        'show chpointer content of e2(100)
      If Check1 = 1 Then
            If Clr1 = 1 Then
               Goto A7
            Else
               Enable Int0
A14:
               If Clr1 = 0 Then Goto A14
               Waitms 5
               Chpointer = 0
               Goto A5
            End If
      Else                                                  'check pressed
A13:
            If Check1 = 0 Then Goto A13
            Waitms 10
            If Chpointer = E2pointer Then
               Gb1 = 400
               Gosub Sumequal

               Sum1 = 0 : Sega = 0
               For Gb = 1 To E2pointer
                  Sum1 = E2(gb)
                  Sega = Sega + Sum1
               Next
               Chpointer = 0
               If Sega < 999999 Then
A9:
                  Gosub Showsega

                  If Clr1 = 1 Then
                     Goto A9
                  Else
                     Waitms 5
A10:
                     If Clr1 = 0 Then
                        Goto A10
                     Else
                        Enable Int0
                        Goto A5
                     End If
                  End If
               Else
                  Gb1 = 500
                  Gosub Over
               End If
            Else
               Goto A8
            End If
      End If
      Enable Int0
   Else
   End If
End If



A5:
'---------------refresh-----------------
Sega = Sum * 1000
Seg = Sega / Calibnum
Segstr = Str(seg)
Select Case Seg
   Case 0 To 9
      Segstr1 = Mid(segstr , 1 , 1)
      Seg1 = Val(segstr1) : Seg2 = 0 : Seg3 = 10 : Seg4 = 10 : Seg5 = 10
   Case 10 To 99
      Segstr2 = Mid(segstr , 1 , 1) : Segstr1 = Mid(segstr , 2 , 1) : Seg3 = 10 : Seg4 = 10 : Seg5 = 10
      Seg1 = Val(segstr1) : Seg2 = Val(segstr2)
   Case 100 To 999
      Segstr3 = Mid(segstr , 1 , 1) : Segstr2 = Mid(segstr , 2 , 1)
      Segstr1 = Mid(segstr , 3 , 1) : Seg4 = 10 : Seg5 = 10
      Seg1 = Val(segstr1) : Seg2 = Val(segstr2) : Seg3 = Val(segstr3)
   Case 1000 To 9999
      Segstr4 = Mid(segstr , 1 , 1) : Segstr3 = Mid(segstr , 2 , 1)
      Segstr2 = Mid(segstr , 3 , 1) : Segstr1 = Mid(segstr , 4 , 1) : Seg5 = 10
      Seg1 = Val(segstr1) : Seg2 = Val(segstr2) : Seg3 = Val(segstr3) : Seg4 = Val(segstr4)
   Case 10000 To 99999
      Segstr5 = Mid(segstr , 1 , 1) : Segstr4 = Mid(segstr , 2 , 1)
      Segstr3 = Mid(segstr , 3 , 1) : Segstr2 = Mid(segstr , 4 , 1) : Segstr1 = Mid(segstr , 5 , 1)
      Seg1 = Val(segstr1) : Seg2 = Val(segstr2) : Seg3 = Val(segstr3) : Seg4 = Val(segstr4)
      Seg5 = Val(segstr5)
End Select


Porta = &B11111110
Portc = Lookup(seg1 , We)
Waitms 1
Porta = &B11111101
Gb2 = Lookup(seg2 , We)
Portc = Gb2 And &B01111111
Waitms 1
Porta = &B11111011
Portc = Lookup(seg3 , We)
Waitms 1
Porta = &B11110111
Portc = Lookup(seg4 , We)
Waitms 1
Porta = &B11101111
Portc = Lookup(seg5 , We)
Waitus 500


Loop


'int0 service------------------
Int0routine:
Disable Int0
Enable Int1
Return
'int1 service------------------
Int1routine:
Disable Int1
If Pind.1 = 0 Then                                          'this is direction of CW

Sum = Sum + 1
If Sum > 99999 Then Sum = 99999


   If Count1 = 9 Then
   Count1 = 0
   Incr Count2
      If Count2 > 9 Then
      Count2 = 0
      Incr Count3
         If Count3 > 9 Then
         Count3 = 0
         Incr Count4
            If Count4 > 9 Then
            Count4 = 0
            Incr Count5
               If Count5 > 9 Then
                Count5 = 9 : Count4 = 9 : Count3 = 9 : Count2 = 9 : Count1 = 9

               End If
            End If
         End If
      End If
   Else
   Incr Count1
   End If

Else                                                        'this is direction of CCW
   Sum = Sum - 1
   If Sum < 0 Then Sum = 0
   If Count1 = 0 Then
   Count1 = 9
   Decr Count2
      If Count2 = 255 Then
      Count2 = 9
      Decr Count3
         If Count3 = 255 Then
         Count3 = 9
         Decr Count4
            If Count4 = 255 Then
            Count4 = 9
            Decr Count5
               If Count5 = 255 Then
               Count5 = 0 : Count4 = 0 : Count3 = 0 : Count2 = 0 : Count1 = 0

               End If
            End If
         End If
      End If
   Else
   Decr Count1
   End If
End If
Enable Int0
Return



We:
Data &HC0 , &HF9 , &HA4 , &HB0 , &H99 , &H92 , &H82 , &HF8 , &H80 , &H90 , &HFF

Rem      (1 to 9 = 1 to 9) and (10= 255 (blank))


'----------------------------------calibrate---------------------------
Calibrate:
'E2pointeree = 0
Gb1 = 800
Gosub Calib
If1:
If Clr1 = 0 Or Check1 = 0 Or Add1 = 0 Then
Goto If1
End If
Waitms 10

Gb1 = 350
Gosub Press
Gosub Check
Gosub After
Gosub A100m
Gb1 = 200
Gosub Go
Enable Int0
If2:
Porta = &B11111110
Portc = Lookup(count1 , We)
Waitms 1
Porta = &B11111101
Portc = Lookup(count2 , We)
Waitms 1
Porta = &B11111011
Portc = Lookup(count3 , We)
Waitms 1
Porta = &B11110111
Portc = Lookup(count4 , We)
Waitms 1
Porta = &B11101111
Portc = Lookup(count5 , We)
Waitms 1

If Check1 = 0 Then
Disable Int0
Waitms 10

Calibnumee = Sum
Gb1 = 250
Gosub Calib
Gosub Rated
Gb1 = 100
Gosub Show00000
Gosub Blank
Gosub Show00000
Gosub Blank
If3:
   If Check1 = 1 Then
   Else
   Goto If3
   End If
Return
End If
Goto If2


Show:
For Gb = 0 To Gb1
Porta = &B11111110
Portc = Lookup(count1 , We)
Waitms 1
Porta = &B11111101
Gb2 = Lookup(count2 , We)
Portc = Gb2 And &B01111111
Waitms 1
Porta = &B11111011
If Adcval > 99 Then
Portc = Lookup(count3 , We)
Else
Portc = 255
End If
Waitms 1
Porta = &B11110111
Portc = 255
Waitms 1
Porta = &B11101111
Portc = 255
Waitms 1
Next Gb
Return

Lo1:
Set Beep
For Gb = 0 To Gb1
Porta = &B11111110
Portc = 255
Waitms 1
Porta = &B11111101
Portc = 255
Waitms 1
Porta = &B11111011
Portc = 255
Waitms 1
Porta = &B11110111
Portc = &HC0 And &B01111111
Waitms 1
Porta = &B11101111
Portc = &HC7
Waitms 1
Next Gb
Reset Beep
Return

Batt:
Set Beep
For Gb = 0 To Gb1
Porta = &B11111110
Portc = 255
Waitms 1
Porta = &B11111101
Portc = &H87 And &B01111111
Waitms 1
Porta = &B11111011
Portc = &H87
Waitms 1
Porta = &B11110111
Portc = &H88
Waitms 1
Porta = &B11101111
Portc = &H83
Waitms 1
Next Gb
Reset Beep
Return

Blank:
For Gb = 0 To Gb1
Porta = &B11111110
Portc = 255
Waitms 1
Porta = &B11111101
Portc = 255
Waitms 1
Porta = &B11111011
Portc = 255
Waitms 1
Porta = &B11110111
Portc = 255
Waitms 1
Porta = &B11101111
Portc = 255
Waitms 1
Next Gb
Return

Turn:
Set Beep
For Gb = 0 To Gb1
Porta = &B11111110
Portc = 255
Waitms 1
Porta = &B11111101
Portc = &HAB
Waitms 1
Porta = &B11111011
Portc = &HAF
Waitms 1
Porta = &B11110111
Portc = &HE3
Waitms 1
Porta = &B11101111
Portc = &H87
Waitms 1
Next Gb
Reset Beep
Return

Off1:
Set Beep
For Gb = 0 To Gb1
Porta = &B11111110
Portc = 255
Waitms 1
Porta = &B11111101
Portc = 255
Waitms 1
Porta = &B11111011
Portc = &H8E
Waitms 1
Porta = &B11110111
Portc = &H8E
Waitms 1
Porta = &B11101111
Portc = &HC0
Waitms 1
Next Gb
Goto Off1
Return

Calib:
Set Beep
For Gb = 0 To Gb1
Porta = &B11111110
Portc = &H83
Waitms 1
Porta = &B11111101
Portc = &HF9
Waitms 1
Porta = &B11111011
Portc = &HC7
Waitms 1
Porta = &B11110111
Portc = &H88
Waitms 1
Porta = &B11101111
Portc = &HC6
Waitms 1
Next Gb
Reset Beep
Return

Rated:
Set Beep
For Gb = 0 To Gb1
Porta = &B11111110
Portc = &HA1
Waitms 1
Porta = &B11111101
Portc = &H86
Waitms 1
Porta = &B11111011
Portc = &H87
Waitms 1
Porta = &B11110111
Portc = &H88
Waitms 1
Porta = &B11101111
Portc = &HAF
Waitms 1
Next Gb
Reset Beep
Return

Show00000:
Set Beep
For Gb = 0 To Gb1
Porta = &B11111110
Portc = &H40
Waitms 1
Porta = &B11111101
Portc = &H40
Waitms 1
Porta = &B11111011
Portc = &H40
Waitms 1
Porta = &B11110111
Portc = &H40
Waitms 1
Porta = &B11101111
Portc = &H40
Waitms 1
Next Gb
Reset Beep
Return

Go:
Set Beep
For Gb = 0 To Gb1
Porta = &B11111110
Portc = &B01111111
Waitms 1
Porta = &B11111101
Portc = &B01111111
Waitms 1
Porta = &B11111011
Portc = &B01111111
Waitms 1
Porta = &B11110111
Portc = &HC0
Waitms 1
Porta = &B11101111
Portc = &HC2
Waitms 1
Next Gb
Reset Beep
Return

Added:
Set Beep
For Gb = 0 To Gb1
Porta = &B11111110
Portc = &HA1
Waitms 1
Porta = &B11111101
Portc = &H86
Waitms 1
Porta = &B11111011
Portc = &HA1
Waitms 1
Porta = &B11110111
Portc = &HA1
Waitms 1
Porta = &B11101111
Portc = &H88
Waitms 1
Next Gb
Reset Beep
Return

Over:
Set Beep
For Gb = 0 To Gb1
Porta = &B11111110
Portc = 255
Waitms 1
Porta = &B11111101
Portc = &HAF
Waitms 1
Porta = &B11111011
Portc = &H86
Waitms 1
Porta = &B11110111
Portc = &HC1
Waitms 1
Porta = &B11101111
Portc = &HC0
Waitms 1
Next Gb
Reset Beep
Return

Clear:
'Set Beep
For Gb = 0 To Gb1
Porta = &B11111110
Portc = &HAF
Waitms 1
Porta = &B11111101
Portc = &H88
Waitms 1
Porta = &B11111011
Portc = &H86
Waitms 1
Porta = &B11110111
Portc = &HC7
Waitms 1
Porta = &B11101111
Portc = &HC6
Waitms 1
Next Gb
'Reset Beep
Return

A100m:

For Gb = 0 To Gb1
Porta = &B11111110
Portc = &HD8
Waitms 1
Porta = &B11111101
Portc = &HCC
Waitms 1
Porta = &B11111011
Portc = &HC0
Waitms 1
Porta = &B11110111
Portc = &HC0
Waitms 1
Porta = &B11101111
Portc = &HF9
Waitms 1
Next Gb

Return

Press:

For Gb = 0 To Gb1
Porta = &B11111110
Portc = &H92
Waitms 1
Porta = &B11111101
Portc = &H92
Waitms 1
Porta = &B11111011
Portc = &H86
Waitms 1
Porta = &B11110111
Portc = &HAF
Waitms 1
Porta = &B11101111
Portc = &H8C
Waitms 1
Next Gb

Return

Check:

For Gb = 0 To Gb1
Porta = &B11111110
Portc = &HC6
Waitms 1
Porta = &B11111101
Portc = &H88
Waitms 1
Porta = &B11111011
Portc = &H86
Waitms 1
Porta = &B11110111
Portc = &H8B
Waitms 1
Porta = &B11101111
Portc = &HC6
Waitms 1
Next Gb

Return

After:

For Gb = 0 To Gb1
Porta = &B11111110
Portc = &HAF
Waitms 1
Porta = &B11111101
Portc = &H86
Waitms 1
Porta = &B11111011
Portc = &H87
Waitms 1
Porta = &B11110111
Portc = &H8E
Waitms 1
Porta = &B11101111
Portc = &H88
Waitms 1
Next Gb

Return

Sumequal:
Set Beep
For Gb = 0 To Gb1
Porta = &B11111110
Portc = &HB7
Waitms 1
Porta = &B11111101
Portc = &HD8
Waitms 1
Porta = &B11111011
Portc = &HCC
Waitms 1
Porta = &B11110111
Portc = &HC1
Waitms 1
Porta = &B11101111
Portc = &H92
Waitms 1
Next Gb
Reset Beep
Return

Showsega:
Segstr = Str(sega)
Gb4 = 0
Select Case Sega
   Case 0 To 9
      Segstr1 = Mid(segstr , 1 , 1)
      Seg1 = Val(segstr1) : Seg2 = 0 : Seg3 = 10 : Seg4 = 10 : Seg5 = 10
   Case 10 To 99
      Segstr2 = Mid(segstr , 1 , 1) : Segstr1 = Mid(segstr , 2 , 1) : Seg3 = 10 : Seg4 = 10 : Seg5 = 10
      Seg1 = Val(segstr1) : Seg2 = Val(segstr2)
   Case 100 To 999
      Segstr3 = Mid(segstr , 1 , 1) : Segstr2 = Mid(segstr , 2 , 1)
      Segstr1 = Mid(segstr , 3 , 1) : Seg4 = 10 : Seg5 = 10
      Seg1 = Val(segstr1) : Seg2 = Val(segstr2) : Seg3 = Val(segstr3)
   Case 1000 To 9999
      Segstr4 = Mid(segstr , 1 , 1) : Segstr3 = Mid(segstr , 2 , 1)
      Segstr2 = Mid(segstr , 3 , 1) : Segstr1 = Mid(segstr , 4 , 1) : Seg5 = 10
      Seg1 = Val(segstr1) : Seg2 = Val(segstr2) : Seg3 = Val(segstr3) : Seg4 = Val(segstr4)
   Case 10000 To 99999
      Segstr5 = Mid(segstr , 1 , 1) : Segstr4 = Mid(segstr , 2 , 1)
      Segstr3 = Mid(segstr , 3 , 1) : Segstr2 = Mid(segstr , 4 , 1) : Segstr1 = Mid(segstr , 5 , 1)
      Seg1 = Val(segstr1) : Seg2 = Val(segstr2) : Seg3 = Val(segstr3) : Seg4 = Val(segstr4)
      Seg5 = Val(segstr5)
   Case 100000 To 999999
      Segstr5 = Mid(segstr , 1 , 1) : Segstr4 = Mid(segstr , 2 , 1)
      Segstr3 = Mid(segstr , 3 , 1) : Segstr2 = Mid(segstr , 4 , 1) : Segstr1 = Mid(segstr , 5 , 1)
      Seg1 = Val(segstr1) : Seg2 = Val(segstr2) : Seg3 = Val(segstr3) : Seg4 = Val(segstr4)
      Seg5 = Val(segstr5) : Gb4 = 1
End Select


Porta = &B11111110
Portc = Lookup(seg1 , We)
Waitms 1
Porta = &B11111101
If Gb4 = 0 Then
Gb2 = Lookup(seg2 , We)
Portc = Gb2 And &B01111111
Else
Portc = Lookup(seg2 , We)
End If
Waitms 1
Porta = &B11111011
Portc = Lookup(seg3 , We)
Waitms 1
Porta = &B11110111
Portc = Lookup(seg4 , We)
Waitms 1
Porta = &B11101111
Portc = Lookup(seg5 , We)
Waitms 1
Return

E2number:

Segstr = Str(e2pointer)
Select Case E2pointer
   Case 0 To 9
      Segstr1 = Mid(segstr , 1 , 1)
      Seg1 = Val(segstr1) : Seg2 = 10 : Seg3 = 10 : Seg4 = 10 : Seg5 = 10
   Case 10 To 99
      Segstr2 = Mid(segstr , 1 , 1) : Segstr1 = Mid(segstr , 2 , 1) : Seg3 = 10 : Seg4 = 10 : Seg5 = 10
      Seg1 = Val(segstr1) : Seg2 = Val(segstr2)
   Case 100
      Segstr3 = Mid(segstr , 1 , 1) : Segstr2 = Mid(segstr , 2 , 1)
      Segstr1 = Mid(segstr , 3 , 1) : Seg4 = 10 : Seg5 = 10
      Seg1 = Val(segstr1) : Seg2 = Val(segstr2) : Seg3 = Val(segstr3)
End Select
Set Beep
For Gb = 0 To Gb1
Porta = &B11111110
Portc = Lookup(seg1 , We)
Waitms 1
Porta = &B11111101
Portc = Lookup(seg2 , We)
Waitms 1
Porta = &B11111011
Portc = Lookup(seg3 , We)
Waitms 1
Porta = &B11110111                                          '=
Portc = &HB7
Waitms 1
Porta = &B11101111                                          'n
Portc = &HAB
Waitms 1
Next
Reset Beep
Return


A11:
Disable Int0
E2pointer = 0
E2pointeree = E2pointer
Set Beep
Gosub Clear
Reset Beep
A12:
If Clr1 = 0 Then Goto A12
Waitms 5
Enable Int0
Goto A5